<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:p="http://primefaces.org/ui">

<style type="text/css">
    .ui-row-editor .ui-row-editor-pencil {
        margin-left:8px;
    }
</style>
<h:head>
    <link type="text/css" rel="stylesheet" href="#{request.contextPath}/themes/cupertino/skin.css"/>
</h:head>


<h:form id="form">
    <p:growl id="msgs" showDetail="true"/>

    <p:dataTable id="projects" var="project" value="#{dtEditView.projects}" editable="true" style="margin-bottom:20px">
        <f:facet name="header">
            Row Editing
        </f:facet>

        <p:ajax event="rowEdit" listener="#{dtEditView.onRowEdit}" update=":form:msgs" />
        <p:ajax event="rowEditCancel" listener="#{dtEditView.onRowCancel}" update=":form:msgs" />

        <p:column headerText="Id">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.id}" /></f:facet>
                <f:facet name="input"><p:inputText id="modelInput" value="#{project.id}" style="width:100%"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Name">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.name}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.name}" style="width:100%" label="Name"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Description">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.description}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.description}" style="width:100%" label="Description"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="User">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.user}" /></f:facet>
                <f:facet name="input">
                    <h:selectOneMenu value="#{project.user}" style="width:100%">
                        <f:selectItems value="#{dtEditView.users}" var="user" itemLabel="#{user}" itemValue="#{user}" />
                    </h:selectOneMenu>
                </f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Date start">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.dateStart}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.dateStart}" style="width:100%" label="Date start"/></f:facet>
            </p:cellEditor>
        </p:column>


        <p:column headerText="Date finish">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.dateFinish}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.dateFinish}" style="width:100%" label="Date finish"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Status">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.status}" /></f:facet>
                <f:facet name="input">
                    <h:selectOneMenu value="#{project.status}" style="width:100%">
                        <f:selectItems value="#{dtEditView.statuses}" var="status" itemLabel="#{status}" itemValue="#{status}" />
                    </h:selectOneMenu>
                </f:facet>
            </p:cellEditor>
        </p:column>

        <p:column style="width:35px">
            <p:rowEditor />
        </p:column>
    </p:dataTable>

    <p:dataTable id="projects2" var="project" value="#{dtEditView.projects2}" editable="true" editMode="cell" widgetVar="cellCars">
        <f:facet name="header">
            Cell Editing with Click and RightClick
        </f:facet>

        <p:ajax event="cellEdit" listener="#{dtEditView.onCellEdit}" update=":form:msgs" />

        <p:column headerText="Id">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.id}" /></f:facet>
                <f:facet name="input"><p:inputText id="modelInput" value="#{project.id}" style="width:96%"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Name">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.name}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.name}" style="width:100%" label="Name"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Description">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.description}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.description}" style="width:100%" label="Description"/></f:facet>
            </p:cellEditor>
        </p:column>


        <p:column headerText="User">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.user}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.user}" style="width:100%" label="User"/></f:facet>
            </p:cellEditor>
        </p:column>


        <p:column headerText="Date start">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.dateStart}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.dateStart}" style="width:100%" label="Date start"/></f:facet>
            </p:cellEditor>
        </p:column>


        <p:column headerText="Date finish">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.dateFinish}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{project.dateFinish}" style="width:100%" label="Date finish"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Status">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{project.status}" /></f:facet>
                <f:facet name="input">
                    <h:selectOneMenu value="#{project.status}" style="width:100%">
                        <f:selectItems value="#{dtEditView.statuses}" var="status" itemLabel="#{status}" itemValue="#{status}" />
                    </h:selectOneMenu>
                </f:facet>
            </p:cellEditor>
        </p:column>

    </p:dataTable>

    <p:contextMenu for="projects2" widgetVar="cMenu">
        <p:menuitem value="Edit Cell" icon="pi pi-search" onclick="PF('cellCars').showCellEditor();return false;"/>
        <p:menuitem value="Hide Menu" icon="pi pi-times" onclick="PF('cMenu').hide()"/>
    </p:contextMenu>
</h:form>

</html>
